/*******************************************************************************
 * University of Illinois/NCSA
 * Open Source License
 *
 * Copyright (c) 2010 , NCSA.  All rights reserved.
 *
 * Developed by:
 * Cyberenvironments and Technologies (CET)
 * http://cet.ncsa.illinois.edu/
 *
 * National Center for Supercomputing Applications (NCSA)
 * http://www.ncsa.illinois.edu/
 *
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the
 * "Software"), to deal with the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 *
 * - Redistributions of source code must retain the above copyright
 *   notice, this list of conditions and the following disclaimers.
 * - Redistributions in binary form must reproduce the above copyright
 *   notice, this list of conditions and the following disclaimers in the
 *   documentation and/or other materials provided with the distribution.
 * - Neither the names of CET, University of Illinois/NCSA, nor the names
 *   of its contributors may be used to endorse or promote products
 *   derived from this Software without specific prior written permission.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 * IN NO EVENT SHALL THE CONTRIBUTORS OR COPYRIGHT HOLDERS BE LIABLE FOR
 * ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
 * CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS WITH THE SOFTWARE.
 *******************************************************************************/
/**
 * 
 */
package edu.uiuc.ncsa.cet.bean.virtualsensor;

import java.util.HashSet;
import java.util.Set;

import edu.uiuc.ncsa.cet.bean.CETBean;
import edu.uiuc.ncsa.cet.bean.gis.GeoPointBean;

/**
 * 
 * Virtual sensor.
 * 
 * @author lmarini@ncsa.uiuc.edu
 * 
 */
public class VirtualSensorBean extends CETBean {

	private static final long serialVersionUID = 1L;

	private String name;

	private String derivedFrom;

	private GeoPointBean location;

	private TemporalFrequencyBean frequency;

	private String thematicInterest;

	private Set<LayerBean> layers = new HashSet<LayerBean>();

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getDerivedFrom() {
		return derivedFrom;
	}

	public void setDerivedFrom(String derivedFrom) {
		this.derivedFrom = derivedFrom;
	}

	public GeoPointBean getLocation() {
		return location;
	}

	public void setLocation(GeoPointBean location) {
		this.location = location;
	}

	public TemporalFrequencyBean getFrequency() {
		return frequency;
	}

	public void setFrequency(TemporalFrequencyBean frequency) {
		this.frequency = frequency;
	}

	public String getThematicInterest() {
		return thematicInterest;
	}

	public void setThematicInterest(String thematicInterest) {
		this.thematicInterest = thematicInterest;
	}

	public Set<LayerBean> getLayers() {
		return layers;
	}

	public void setLayers(Set<LayerBean> layers) {
		this.layers = layers;
	}

	public void addLayer(LayerBean layer) {
		this.layers.add(layer);
	}
}
